#ifdef ASSEMBLER
COMMAND(.ALIGN, DIREC,  D_ALIGN,   NIX,NIX,NIX)
COMMAND(.ASCII, DIREC,  D_ASCII,   NIX,NIX,NIX)
COMMAND(.ASCIZ, DIREC,  D_ASCIZ,   NIX,NIX,NIX)
COMMAND(.BLA1,  DIREC,  D_BLA,     NIX,NIX,NIX)
COMMAND(.BLUB,  DIREC,  D_BLUB,    NIX,NIX,NIX)
COMMAND(.BSS,   DIREC,  D_BSS,     NIX,NIX,NIX)
COMMAND(.BYTE,  DIREC,  D_BYTE,    NIX,NIX,NIX)
COMMAND(.COMM,  DIREC,  D_COMM,    NIX,NIX,NIX)
COMMAND(.DATA,  DIREC,  D_DATA,    NIX,NIX,NIX)
COMMAND(.DOUBLE,DIREC,  D_DOUBLE,  NIX,NIX,NIX)
COMMAND(.FLOAT, DIREC,  D_FLOAT,   NIX,NIX,NIX)
COMMAND(.GLOBL, DIREC,  D_GLOBL,   NIX,NIX,NIX)
COMMAND(.HWORD, DIREC,  D_HWORD,   NIX,NIX,NIX)
COMMAND(.INT,   DIREC,  D_INT,     NIX,NIX,NIX)
COMMAND(.LCOMM, DIREC,  D_LCOMM,   NIX,NIX,NIX)
COMMAND(.LONG,  DIREC,  D_LONG,    NIX,NIX,NIX)
COMMAND(.ORG,   DIREC,  D_ORG,     NIX,NIX,NIX)
COMMAND(.SECTION,DIREC, D_SECTION, NIX,NIX,NIX)
COMMAND(.SINGLE, DIREC, D_FLOAT,   NIX,NIX,NIX)
COMMAND(.SPACE, DIREC,  D_SPACE,   NIX,NIX,NIX)
COMMAND(.STABD, DIREC,  D_STAB,    NIX,NIX,NIX)
COMMAND(.STABN, DIREC,  D_STAB,    NIX,NIX,NIX)
COMMAND(.STABS, DIREC,  D_STAB,    NIX,NIX,NIX)
COMMAND(.TEXT,  DIREC,  D_TEXT,    NIX,NIX,NIX)
COMMAND(.WORD,  DIREC,  D_WORD,    NIX,NIX,NIX)  
#endif

COMMAND(ADC    ,BEFEHL, 0x82000000,RX,S2,RD)
COMMAND(ADD    ,BEFEHL, 0x80000000,RX,S2,RD)
COMMAND(AND    ,BEFEHL, 0x8A000000,RX,S2,RD)
COMMAND(ASL    ,BEFEHL, 0x94000000,RX,S2,RD)
COMMAND(ASR    ,BEFEHL, 0x96000000,RX,S2,RD)

#ifdef ASSEMBLER
#define CC(c,d) COMMAND(B##c ,BEFEHL, 0xC0000000 | (d << 20),RI19,NIX,NIX)
CC(CC,12)
CC(CS,4)
CC(DC,30)
CC(DS,22)
CC(EQ,2)
CC(FC,25)
CC(FS,17)
CC(GE,15)
CC(GT,14)
CC(HI,13)
CC(KC,31)
CC(KS,23)
CC(LE,6)
CC(LM,21)
CC(LN,28)
CC(LP,29)
CC(LS,5)
CC(LT,7)
CC(LZ,20)
CC(MC,24)
CC(MI,1)
CC(MS,16)
CC(NC,26)
CC(NE,10)
CC(NP,8)
CC(NS,18)
CC(PL,9)
CC(RA,0)
CC(SC,27)
#else
COMMAND(B ,BEFEHL, 0xC0000000, RI19,NIX,NIX)
#endif

COMMAND(BSRG   ,BEFEHL, 0xE0000000,RD,RI19,NIX)
COMMAND(BSRL   ,BEFEHL, 0xE4000000,RD,RI19,NIX)
#ifdef ASSEMBLER
CC(SS,19)
CC(VC,11)
CC(VS,3)
#undef CC
#endif

COMMAND(CREA   ,BEFEHL, 0x72000000,S2,RD,NIX)
COMMAND(DIE    ,BEFEHL, 0x7E100001,NIX,NIX,NIX)

#ifdef ASSEMBLER
COMMAND(F2     ,REG,    3,         NIX,NIX,NIX)  
#endif

COMMAND(FADA   ,BEFEHL, 0xA4000000,RX,RY,RD)
COMMAND(FADD   ,BEFEHL, 0xA0000000,RX,RY,RD)

#ifdef ASSEMBLER
#define CC(c,d) COMMAND(FB##c ,BEFEHL, 0xC4000000 | (d << 20),RI19,NIX,NIX)
CC(AIC,31)
CC(AIS,23)
CC(ASC,30)
CC(ASS,22)
CC(EQ,1)
CC(FXC,29)
CC(FXS,21)
CC(GLE,11)
CC(IEX,4)
CC(INF,2)
CC(IOP,5)
CC(MI,0)
CC(NAN,3)
CC(NE,9)
CC(NIE,12)
CC(NIN,10)
CC(NIO,13)
CC(NOF,15)
CC(NUF,14)
CC(OF,7)
CC(OGE,17)
CC(OGL,20)
CC(OGT,16)
CC(OLE,19)
CC(OLT,18)
CC(PL,8)
CC(UEQ,28)
CC(UF,6)
CC(UGE,26)
CC(UGT,27)
CC(ULE,24)
CC(ULT,25)
#undef CC
#else
COMMAND(FB, BEFEHL, 0xC4000000, RI19,NIX,NIX)
#endif

#ifdef ASSEMBLER
#define CC(c,d) COMMAND(FJ##c ,BEFEHL, 0xC4000000 | (d << 20),SPEC,NIX,NIX)
CC(AIC,31)
CC(AIS,23)
CC(ASC,30)
CC(ASS,22)
CC(EQ,1)
CC(FXC,29)
CC(FXS,21)
CC(GLE,11)
CC(IEX,4)
CC(INF,2)
CC(IOP,5)
CC(MI,0)
CC(NAN,3)
CC(NE,9)
CC(NIE,12)
CC(NIN,10)
CC(NIO,13)
CC(NOF,15)
CC(NUF,14)
CC(OF,7)
CC(OGE,17)
CC(OGL,20)
CC(OGT,16)
CC(OLE,19)
CC(OLT,18)
CC(PL,8)
CC(UEQ,28)
CC(UF,6)
CC(UGE,26)
CC(UGT,27)
CC(ULE,24)
CC(ULT,25)
#undef CC
#else
COMMAND(FJ, BEFEHL, 0xCB000000, SPEC, NIX, NIX)
COMMAND(FJ2, BEFEHL, 0xD4000000, SPEC, NIX, NIX)
#endif

COMMAND(FMLA   ,BEFEHL, 0xAA000000,RX,RY,RD)
COMMAND(FMUL   ,BEFEHL, 0xA8000000,RX,RY,RD)
#ifdef ASSEMBLER
COMMAND(FP     ,REG,    3,         NIX,NIX,NIX)
#endif

COMMAND(FSBA   ,BEFEHL, 0xA6000000,RX,RY,RD)
COMMAND(FSUB   ,BEFEHL, 0xA2000000,RY,RX,RD)
COMMAND(FTOI   ,BEFEHL, 0xAC000000,RY,RD,NIX)
COMMAND(GETA   ,BEFEHL, 0x48000000,RD,NIX,NIX)
COMMAND(GETBAS ,BEFEHL, 0x6E000000,RD,NIX,NIX)
COMMAND(GETCT  ,BEFEHL, 0x4C000000,RD,NIX,NIX)
COMMAND(GETH   ,BEFEHL, 0xB8000000,I19,RD,NIX)
COMMAND(GETHI  ,BEFEHL, 0xB8000000,SI19,RD,NIX)
COMMAND(GETLD  ,BEFEHL, 0x40007FFF,RD,NIX,NIX)
COMMAND(GETLO  ,BEFEHL, 0xBC000000,I19,RD,NIX)
COMMAND(GETLOG ,BEFEHL, 0x46007FFF,RD,NIX,NIX)
COMMAND(GETMOD ,BEFEHL, 0x44007FFF,RD,NIX,NIX)
COMMAND(GETNR  ,BEFEHL, 0x4A000000,RD,NIX,NIX)
COMMAND(GETPR  ,BEFEHL, 0x4E000000,RD,NIX,NIX)
COMMAND(GETSEC ,BEFEHL, 0x6C000000,RY,RD,NIX)
COMMAND(GETSR  ,BEFEHL, 0x42007FFF,RD,NIX,NIX)
COMMAND(HOP    ,BEFEHL, 0x7C100001,NIX,NIX,NIX)
COMMAND(HOPSEC ,BEFEHL, 0x78100001,NIX,NIX,NIX)
COMMAND(IOP    ,BEFEHL, 0x20000000,NIX,NIX,NIX)
COMMAND(ITOF   ,BEFEHL, 0xAE000000,S2,RD,NIX)

#ifdef ASSEMBLER
#define CC(c,d) COMMAND(J##c ,BEFEHL, 0xC0000000 | (d << 20),SPEC,NIX,NIX)
CC(CC,12)
CC(CS,4)
CC(DC,30)
CC(DS,22)
CC(EQ,2)
#else
COMMAND(J, BEFEHL, 0xC8000000, SPEC, NIX, NIX)
COMMAND(J2, BEFEHL, 0xD0000000, SPEC, NIX, NIX)
#endif

COMMAND(JEXG   ,BEFEHL, 0xF0000000,RD,I19,NIX)
COMMAND(JEXL   ,BEFEHL, 0xF4000000,RD,I19,NIX)

#ifdef ASSEMBLER
CC(FC,25)
CC(FS,17)
CC(GE,15)
CC(GT,14)
CC(HI,13)
CC(KC,31)
CC(KS,23) 
CC(LE,6)
CC(LM,21)
CC(LN,28)
CC(LP,29)
CC(LS,5)
CC(LT,7)
CC(LZ,20)
CC(MC,24)
CC(MI,1)
CC(MS,16)
CC(NC,26)
CC(NE,10)
CC(NP,8)
CC(NS,18)
CC(PL,9)
CC(RA,0)
CC(SC,27)
#endif

COMMAND(JSRG   ,BEFEHL, 0xE8000000,RD,RX,S2)
COMMAND(JSRL   ,BEFEHL, 0xEC000000,RD,RX,S2)

#ifdef ASSEMBLER
CC(SS,19)
CC(VC,11)
CC(VS,3)
#undef CC
#endif

COMMAND(LDG    ,BEFEHL, 0x08000000,RX,S2,RD)
COMMAND(LDGN   ,BEFEHL, 0x08000000,RX,S2,RL)
COMMAND(LDL    ,BEFEHL, 0x0C000000,RX,S2,RD)
COMMAND(LSL    ,BEFEHL, 0x90000000,RX,S2,RD)
COMMAND(LSR    ,BEFEHL, 0x92000000,RX,S2,RD)
COMMAND(MLHS   ,BEFEHL, 0xB4000000,RX,S2,RD)
COMMAND(MLHU   ,BEFEHL, 0xB6000000,RX,S2,RD)
COMMAND(MOV    ,BEFEHL, 0x80000000,S2,RD,NIX)
COMMAND(MPADD  ,BEFEHL, 0x16004000,RX,I13,RD)
COMMAND(MPADDN ,BEFEHL, 0x16004000,RX,I13,RL)
COMMAND(MPAND  ,BEFEHL, 0x10004000,RX,I13,RD)
COMMAND(MPANDN ,BEFEHL, 0x10004000,RX,I13,RL)
COMMAND(MPMAX  ,BEFEHL, 0x14004000,RX,I13,RD)
COMMAND(MPMAXN ,BEFEHL, 0x14004000,RX,I13,RL)
COMMAND(MPOR   ,BEFEHL, 0x12004000,RX,I13,RD)
COMMAND(MPORN  ,BEFEHL, 0x12004000,RX,I13,RL)
COMMAND(MUL    ,BEFEHL, 0xB2000000,RX,S2,RD)
COMMAND(NAND   ,BEFEHL, 0x8C000000,RX,S2,RD)
COMMAND(NOP    ,BEFEHL, 0xB8000000,NIX,NIX,NIX)
COMMAND(OR     ,BEFEHL, 0x88000000,RX,S2,RD)

#ifdef ASSEMBLER
COMMAND(PC     ,REG,    1,         NIX,NIX,NIX)
COMMAND(PGCC_FP,  REG,    3,         NIX,NIX,NIX)
COMMAND(PGCC_PAR1,REG,    7,         NIX,NIX,NIX)
COMMAND(PGCC_PAR2,REG,    8,         NIX,NIX,NIX)
COMMAND(PGCC_PAR3,REG,    9,         NIX,NIX,NIX)
COMMAND(PGCC_PAR4,REG,   10,         NIX,NIX,NIX)
COMMAND(PGCC_RET, REG,    5,         NIX,NIX,NIX)
COMMAND(PGCC_SC,  REG,    4,         NIX,NIX,NIX)
COMMAND(PGCC_SP,  REG,    6,         NIX,NIX,NIX)
COMMAND(PGCC_SPHI,REG,   11,         NIX,NIX,NIX)
#endif

COMMAND(POPG   ,BEFEHL, 0x18007FFF,RX,RD,NIX)
COMMAND(POPGN  ,BEFEHL, 0x18007FFF,RX,RL,NIX)
COMMAND(POPIG  ,BEFEHL, 0x1A004000,RX,I13,RD)
COMMAND(POPIGN ,BEFEHL, 0x1A004000,RX,I13,RL)
COMMAND(POPIL  ,BEFEHL, 0x1E004000,RX,I13,RD)
COMMAND(POPL   ,BEFEHL, 0x1C007FFF,RX,RD,NIX)
COMMAND(POPNG  ,BEFEHL, 0x18004000,RX,I13,RD)
COMMAND(POPNGN ,BEFEHL, 0x18004000,RX,I13,RL)
COMMAND(POPNL  ,BEFEHL, 0x1C004000,RX,I13,RD)
COMMAND(PSHG   ,BEFEHL, 0x38004000,RD,RX,NIX)
COMMAND(PSHGC  ,BEFEHL, 0x38000000,RX,NIX,NIX)
COMMAND(PSHIG  ,BEFEHL, 0x38004000,RD,RX,I13)
COMMAND(PSHIL  ,BEFEHL, 0x3C004000,RD,RX,I13)
COMMAND(PSHL   ,BEFEHL, 0x3C004000,RD,RX,NIX)
COMMAND(PSHLC  ,BEFEHL, 0x3C004000,RX,NIX,NIX)
COMMAND(PSHNG  ,BEFEHL, 0x3A004000,RD,RX,I13)
COMMAND(PSHNL  ,BEFEHL, 0x3E004000,RD,RX,I13)
COMMAND(PUTA   ,BEFEHL, 0x58000000,S2,NIX,NIX)
COMMAND(PUTBAS ,BEFEHL, 0x6A000000,S2,NIX,NIX)
COMMAND(PUTCRE ,BEFEHL, 0x70000000,S2,RD,NIX)
COMMAND(PUTCT  ,BEFEHL, 0x5C000000,S2,NIX,NIX)
COMMAND(PUTLD  ,BEFEHL, 0x50000000,RX,S2,NIX)
COMMAND(PUTLOG ,BEFEHL, 0x56000000,RX,S2,NIX)
COMMAND(PUTMOD ,BEFEHL, 0x54000000,RX,S2,NIX)
COMMAND(PUTNR  ,BEFEHL, 0x5A000000,S2,NIX,NIX)
COMMAND(PUTPR  ,BEFEHL, 0x5E000000,S2,NIX,NIX)
COMMAND(PUTSEC, BEFEHL, 0x68000000,S2,RD,NIX)
COMMAND(PUTSR  ,BEFEHL, 0x52000000,RX,S2,NIX)

#ifdef ASSEMBLER
COMMAND(R0     ,REG,    0,         NIX,NIX,NIX)
COMMAND(R1     ,REG,    1,         NIX,NIX,NIX)
COMMAND(R10    ,REG,    10,        NIX,NIX,NIX)
COMMAND(R11    ,REG,    11,        NIX,NIX,NIX)
COMMAND(R12    ,REG,    12,        NIX,NIX,NIX)
COMMAND(R13    ,REG,    13,        NIX,NIX,NIX)
COMMAND(R14    ,REG,    14,        NIX,NIX,NIX)
COMMAND(R15    ,REG,    15,        NIX,NIX,NIX)
COMMAND(R16    ,REG,    16,        NIX,NIX,NIX)
COMMAND(R17    ,REG,    17,        NIX,NIX,NIX)
COMMAND(R18    ,REG,    18,        NIX,NIX,NIX)
COMMAND(R19    ,REG,    19,        NIX,NIX,NIX)
COMMAND(R2     ,REG,    2,         NIX,NIX,NIX)
COMMAND(R20    ,REG,    20,        NIX,NIX,NIX)
COMMAND(R21    ,REG,    21,        NIX,NIX,NIX)
COMMAND(R22    ,REG,    22,        NIX,NIX,NIX)
COMMAND(R23    ,REG,    23,        NIX,NIX,NIX)
COMMAND(R24    ,REG,    24,        NIX,NIX,NIX)
COMMAND(R25    ,REG,    25,        NIX,NIX,NIX)
COMMAND(R26    ,REG,    26,        NIX,NIX,NIX)
COMMAND(R27    ,REG,    27,        NIX,NIX,NIX)
COMMAND(R28    ,REG,    28,        NIX,NIX,NIX)
COMMAND(R29    ,REG,    29,        NIX,NIX,NIX)
COMMAND(R3     ,REG,    3,         NIX,NIX,NIX)
COMMAND(R30    ,REG,    30,        NIX,NIX,NIX)
COMMAND(R31    ,REG,    31,        NIX,NIX,NIX)
COMMAND(R4     ,REG,    4,         NIX,NIX,NIX)
COMMAND(R5     ,REG,    5,         NIX,NIX,NIX)
COMMAND(R6     ,REG,    6,         NIX,NIX,NIX)
COMMAND(R7     ,REG,    7,         NIX,NIX,NIX)
COMMAND(R8     ,REG,    8,         NIX,NIX,NIX)
COMMAND(R9     ,REG,    9,         NIX,NIX,NIX)
#endif

COMMAND(RES    ,BEFEHL, 0x60000000,I19,NIX,NIX)
COMMAND(RET    ,BEFEHL, 0x18117FFF,NIX,NIX,NIX)
COMMAND(RM     ,BEFEHL, 0xB0000000,S2,RD,NIX)
COMMAND(ROCL   ,BEFEHL, 0x9C000000,RX,S2,RD)        /* */
COMMAND(ROCR   ,BEFEHL, 0x9E000000,RX,S2,RD)        /* */
COMMAND(ROL    ,BEFEHL, 0x98000000,RX,S2,RD)
COMMAND(ROR    ,BEFEHL, 0x9A000000,RX,S2,RD)

#ifdef ASSEMBLER
COMMAND(S2     ,REG,    2,         NIX,NIX,NIX)
#endif

COMMAND(SBC    ,BEFEHL, 0x86000000,RX,S2,RD)
COMMAND(SETCRE ,BEFEHL, 0x72000000,S2,RD,NIX)

#ifdef ASSEMBLER
COMMAND(SP     ,REG,    2,         NIX,NIX,NIX)
COMMAND(SR     ,REG,    0,         NIX,NIX,NIX)
COMMAND(SSP    ,REG,    2,         NIX,NIX,NIX)
#endif

COMMAND(STG    ,BEFEHL, 0x28004000,RD,RX,I13)
COMMAND(STGC   ,BEFEHL, 0x28000000,RX,NIX,NIX)
COMMAND(STL    ,BEFEHL, 0x2C004000,RD,RX,I13)
COMMAND(STLC   ,BEFEHL, 0x2C004000,RX,NIX,NIX)
COMMAND(SUB    ,BEFEHL, 0x84000000,RX,S2,RD)
COMMAND(SYNCADD,BEFEHL, 0x36004000,RD,RX,I13)
COMMAND(SYNCAND,BEFEHL, 0x30004000,RD,RX,I13)
COMMAND(SYNCMAX,BEFEHL, 0x34004000,RD,RX,I13)
COMMAND(SYNCOR ,BEFEHL, 0x32004000,RD,RX,I13)
COMMAND(SYSC   ,BEFEHL, 0xD8000000,NIX,NIX,NIX)

#ifdef ASSEMBLER
COMMAND(USP    ,REG,    6,         NIX,NIX,NIX)
COMMAND(USPHI  ,REG,    11,        NIX,NIX,NIX)
#endif

COMMAND(XOR    ,BEFEHL, 0x8E000000,RX,S2,RD)
COMMAND(ZZZA   ,BEFEHL, 0xF8000000,I19,NIX,NIX)
COMMAND(ZZZF   ,BEFEHL, 0xFA000000,RD,NIX,NIX)
COMMAND(ZZZH   ,BEFEHL, 0xFE000000,I19,NIX,NIX)
COMMAND(ZZZR   ,BEFEHL, 0xFC000000,RD,NIX,NIX)















